﻿using Microsoft.Extensions.Caching.Memory;
using Microsoft.Extensions.Primitives;
using System;
using System.Threading;

namespace CoreCache
{
    class Program
    {
        static void Main(string[] args)
        {
            //设置cache的最大限制是：100
            MemoryCache memoryCache = new MemoryCache(new MemoryCacheOptions()
            {
                SizeLimit = 100,
            });



            MemoryCacheEntryOptions cacheOptin = new MemoryCacheEntryOptions()
            {
                //被动过期   这种情况只有当再去查询这个缓存的时候，才会出发他的回调函数。不是实时的
                AbsoluteExpiration = DateTimeOffset.Now.AddSeconds(10),
                //滑动过期
                //SlidingExpiration=new TimeSpan(100)
            };
            cacheOptin.Priority = CacheItemPriority.High;
            cacheOptin.SetPriority(CacheItemPriority.High);
            cacheOptin.Size = 1;
            cacheOptin.RegisterPostEvictionCallback((k, v, r, s) =>
            {
                Console.WriteLine(k + "：guoqi ");
            });
            memoryCache.Set<string>("nihao", "value", cacheOptin);
            Console.WriteLine(memoryCache.Get<string>("nihao"));






            //主动过期，程序控制过期
            //主动过期  tokenSource.Cancel();也会出发回调函数
            CancellationTokenSource tokenSource = new CancellationTokenSource();
            cacheOptin.AddExpirationToken(new CancellationChangeToken(tokenSource.Token));
            memoryCache.Set<string>("nihao1", "value1", cacheOptin);
            Console.WriteLine(memoryCache.Get<string>("nihao"));
            Console.WriteLine(memoryCache.Get<string>("nihao1"));
            tokenSource.Cancel();
            //tokenSource.CancelAfter(1000 * 2);
            Console.WriteLine(memoryCache.Get<string>("nihao"));
            Console.WriteLine(memoryCache.Get<string>("nihao1"));
            //memoryCache.GetOrCreate<string>("1", t => "1");




            for (int i = 0; i < 9   ; i++)
            {
                memoryCache.Set<string>(i, i.ToString(), cacheOptin);
            }
            //压缩20%。剩余80%  。移除的时候，根据过期时间  优先级等操作
            memoryCache.Compact(0.2);
            Console.WriteLine(memoryCache.Count); 

            Console.ReadKey();
        }
    }
}
